import odeToJava.*;   // import for use of package components
import odeToJava.modules.*;
import odeToJava.functions.*;
import odeToJava.plotter.*;
import odeToJava.interpolants.*;

/*
   the template class
*/
public class ImexSDTemplate
{
     /*
        main
     */
     public static void main(String[] args)
     {

          /*
             this is where the template essentially starts
          */

          // the function
          
          ODE function = new FunctionTemplate();   // define function in FunctionTemplate.java

          // the span
          
          Span span = new Span(/*t0*/, /*tf*/);   // only first constructor scheme (no interpolation)

          // the initial vector value(s)

          int n =   // indicate the dimension of the problem

          double[] u = new double[n];   // initialize array object

          u[0] =   // fill the array with the initial values
          // etc . . .

          // initial stepsize
          
          double h0 =   // must be > 0

          // the Butcher tableau

          int s =   // specify the stage of the method

          double[][] a = new double[s][s];   // initialize components
          double[][] ahat = new double[s][s];
          double[] b = new double[s];
          double[] bhat = new double[s];

          a[0][0] =   // fill in tableau's a matrix
          // etc . . .
     
          ahat[0][0] =   // fill in tableau's ahat matrix
          // etc . . .

          b[0] =   // fill in tableau's b array
          // etc . . .
		
          bhat[0] =   // fill in tableau's bhat array
          // etc . . .

          Btableau butcher = new Btableau(a, ahat, b, bhat);   // initialize object with components

          // absolute tolerance

          double atol =   // fill in value

          // relative tolerance
          
          double rtol =   // fill in value

          // the file name
          
          String fileName = "";   // default to no file writing

          // stats option
          
          String stats =   // choose 1) "Stats_On" 2) "Stats_Intermediate or 3) "Stats_Off"

          /*
             this is where the template essentially ends
          */

          // run the IMEX /w step doubling scheme with above parameters

          ImexSD.imex_sd(function, span, u, h0, butcher, atol, rtol, fileName, stats);
     }
}
